/* System.c generated by valac 0.56.13, the Vala compiler
 * generated from System.vala, do not modify */

/*
 * Copyright 2011-2013 Robert Dyer
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite-7.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

enum  {
	GRANITE_SERVICES_SYSTEM_0_PROPERTY,
	GRANITE_SERVICES_SYSTEM_NUM_PROPERTIES
};
static GParamSpec* granite_services_system_properties[GRANITE_SERVICES_SYSTEM_NUM_PROPERTIES];

#define GRANITE_PORTAL_TYPE_SETTINGS (granite_portal_settings_get_type ())
#define GRANITE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettings))
#define GRANITE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_PORTAL_TYPE_SETTINGS))
#define GRANITE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_PORTAL_TYPE_SETTINGS, GranitePortalSettingsIface))

typedef struct _GranitePortalSettings GranitePortalSettings;
typedef struct _GranitePortalSettingsIface GranitePortalSettingsIface;

#define GRANITE_PORTAL_TYPE_SETTINGS_PROXY (granite_portal_settings_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _GranitePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (GranitePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (GranitePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

static gpointer granite_services_system_parent_class = NULL;
static GSettingsSchema* granite_services_system_privacy_settings_schema;
static GSettingsSchema* granite_services_system_privacy_settings_schema = NULL;
static GSettings* granite_services_system_privacy_settings;
static GSettings* granite_services_system_privacy_settings = NULL;
static GranitePortalSettings* granite_services_system_portal;
static GranitePortalSettings* granite_services_system_portal = NULL;

VALA_EXTERN GType granite_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
 G_GNUC_INTERNAL guint granite_portal_settings_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
 G_GNUC_INTERNAL GType granite_portal_settings_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL GranitePortalSettings* granite_portal_settings_get (GError** error);
 G_GNUC_INTERNAL GHashTable* granite_portal_settings_read_all (GranitePortalSettings* self,
                                              gchar** namespaces,
                                              gint namespaces_length1,
                                              GError** error);
static void granite_services_system_finalize (GObject * obj);
static GType granite_services_system_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
         * Returns whether history is enabled within the Security and Privacy system settings or not. A value of true
         * means that you should store information such as the last opened file or a history within the app.
         *
         * Checks the "remember_recent_files" key in "org.gnome.desktop.privacy", returning true if the schema does not exist.
         */
gboolean
granite_services_system_history_is_enabled (void)
{
	GSettingsSchema* _tmp22_;
	gboolean _tmp25_ = FALSE;
	GSettingsSchema* _tmp26_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		GranitePortalSettings* _tmp0_;
		GHashTable* schemes = NULL;
		GranitePortalSettings* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		GHashTable* _tmp8_;
		GHashTable* _tmp9_;
		gboolean _tmp10_ = FALSE;
		GHashTable* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
#line 24 "../lib/Services/System.vala"
		_tmp0_ = granite_services_system_portal;
#line 24 "../lib/Services/System.vala"
		if (_tmp0_ == NULL) {
#line 103 "System.c"
			GranitePortalSettings* _tmp1_ = NULL;
			GranitePortalSettings* _tmp2_;
			GranitePortalSettings* _tmp3_;
#line 25 "../lib/Services/System.vala"
			_tmp2_ = granite_portal_settings_get (&_inner_error0_);
#line 25 "../lib/Services/System.vala"
			_tmp1_ = _tmp2_;
#line 25 "../lib/Services/System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "System.c"
				goto __catch0_g_error;
			}
#line 25 "../lib/Services/System.vala"
			_tmp3_ = _tmp1_;
#line 25 "../lib/Services/System.vala"
			_tmp1_ = NULL;
#line 25 "../lib/Services/System.vala"
			_g_object_unref0 (granite_services_system_portal);
#line 25 "../lib/Services/System.vala"
			granite_services_system_portal = _tmp3_;
#line 24 "../lib/Services/System.vala"
			_g_object_unref0 (_tmp1_);
#line 126 "System.c"
		}
#line 28 "../lib/Services/System.vala"
		_tmp4_ = granite_services_system_portal;
#line 28 "../lib/Services/System.vala"
		_tmp5_ = g_strdup ("org.gnome.desktop.privacy");
#line 28 "../lib/Services/System.vala"
		_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 28 "../lib/Services/System.vala"
		_tmp6_[0] = _tmp5_;
#line 28 "../lib/Services/System.vala"
		_tmp7_ = _tmp6_;
#line 28 "../lib/Services/System.vala"
		_tmp7__length1 = 1;
#line 28 "../lib/Services/System.vala"
		_tmp8_ = granite_portal_settings_read_all (_tmp4_, _tmp7_, (gint) 1, &_inner_error0_);
#line 28 "../lib/Services/System.vala"
		_tmp9_ = _tmp8_;
#line 28 "../lib/Services/System.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 28 "../lib/Services/System.vala"
		schemes = _tmp9_;
#line 28 "../lib/Services/System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "System.c"
			goto __catch0_g_error;
		}
#line 29 "../lib/Services/System.vala"
		_tmp11_ = schemes;
#line 29 "../lib/Services/System.vala"
		_tmp12_ = g_hash_table_size (_tmp11_);
#line 29 "../lib/Services/System.vala"
		_tmp13_ = _tmp12_;
#line 29 "../lib/Services/System.vala"
		if (_tmp13_ > ((guint) 0)) {
#line 161 "System.c"
			GHashTable* _tmp14_;
			gconstpointer _tmp15_;
#line 29 "../lib/Services/System.vala"
			_tmp14_ = schemes;
#line 29 "../lib/Services/System.vala"
			_tmp15_ = g_hash_table_lookup (_tmp14_, "org.gnome.desktop.privacy");
#line 29 "../lib/Services/System.vala"
			_tmp10_ = g_hash_table_contains ((GHashTable*) _tmp15_, "remember-recent-files");
#line 170 "System.c"
		} else {
#line 29 "../lib/Services/System.vala"
			_tmp10_ = FALSE;
#line 174 "System.c"
		}
#line 29 "../lib/Services/System.vala"
		if (_tmp10_) {
#line 178 "System.c"
			GHashTable* _tmp16_;
			gconstpointer _tmp17_;
			gconstpointer _tmp18_;
#line 30 "../lib/Services/System.vala"
			_tmp16_ = schemes;
#line 30 "../lib/Services/System.vala"
			_tmp17_ = g_hash_table_lookup (_tmp16_, "org.gnome.desktop.privacy");
#line 30 "../lib/Services/System.vala"
			_tmp18_ = g_hash_table_lookup ((GHashTable*) _tmp17_, "remember-recent-files");
#line 30 "../lib/Services/System.vala"
			result = g_variant_get_boolean ((GVariant*) _tmp18_);
#line 30 "../lib/Services/System.vala"
			_g_hash_table_unref0 (schemes);
#line 30 "../lib/Services/System.vala"
			return result;
#line 194 "System.c"
		}
#line 23 "../lib/Services/System.vala"
		_g_hash_table_unref0 (schemes);
#line 198 "System.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 23 "../lib/Services/System.vala"
		e = _inner_error0_;
#line 23 "../lib/Services/System.vala"
		_inner_error0_ = NULL;
#line 33 "../lib/Services/System.vala"
		_tmp19_ = e;
#line 33 "../lib/Services/System.vala"
		_tmp20_ = _tmp19_->message;
#line 33 "../lib/Services/System.vala"
		g_debug ("System.vala:33: cannot use portal, using GSettings: %s", _tmp20_);
#line 23 "../lib/Services/System.vala"
		_g_error_free0 (e);
#line 218 "System.c"
	}
	__finally0:
#line 23 "../lib/Services/System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "System.c"
		gboolean _tmp21_ = FALSE;
#line 23 "../lib/Services/System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 23 "../lib/Services/System.vala"
		g_clear_error (&_inner_error0_);
#line 23 "../lib/Services/System.vala"
		return _tmp21_;
#line 231 "System.c"
	}
#line 36 "../lib/Services/System.vala"
	_tmp22_ = granite_services_system_privacy_settings_schema;
#line 36 "../lib/Services/System.vala"
	if (_tmp22_ == NULL) {
#line 237 "System.c"
		GSettingsSchemaSource* _tmp23_;
		GSettingsSchema* _tmp24_;
#line 37 "../lib/Services/System.vala"
		_tmp23_ = g_settings_schema_source_get_default ();
#line 37 "../lib/Services/System.vala"
		_tmp24_ = g_settings_schema_source_lookup (_tmp23_, "org.gnome.desktop.privacy", TRUE);
#line 37 "../lib/Services/System.vala"
		_g_settings_schema_unref0 (granite_services_system_privacy_settings_schema);
#line 37 "../lib/Services/System.vala"
		granite_services_system_privacy_settings_schema = _tmp24_;
#line 248 "System.c"
	}
#line 40 "../lib/Services/System.vala"
	_tmp26_ = granite_services_system_privacy_settings_schema;
#line 40 "../lib/Services/System.vala"
	if (_tmp26_ != NULL) {
#line 254 "System.c"
		GSettingsSchema* _tmp27_;
#line 40 "../lib/Services/System.vala"
		_tmp27_ = granite_services_system_privacy_settings_schema;
#line 40 "../lib/Services/System.vala"
		_tmp25_ = g_settings_schema_has_key (_tmp27_, "remember-recent-files");
#line 260 "System.c"
	} else {
#line 40 "../lib/Services/System.vala"
		_tmp25_ = FALSE;
#line 264 "System.c"
	}
#line 40 "../lib/Services/System.vala"
	if (_tmp25_) {
#line 268 "System.c"
		GSettings* _tmp28_;
		GSettings* _tmp30_;
#line 41 "../lib/Services/System.vala"
		_tmp28_ = granite_services_system_privacy_settings;
#line 41 "../lib/Services/System.vala"
		if (_tmp28_ == NULL) {
#line 275 "System.c"
			GSettings* _tmp29_;
#line 42 "../lib/Services/System.vala"
			_tmp29_ = g_settings_new ("org.gnome.desktop.privacy");
#line 42 "../lib/Services/System.vala"
			_g_object_unref0 (granite_services_system_privacy_settings);
#line 42 "../lib/Services/System.vala"
			granite_services_system_privacy_settings = _tmp29_;
#line 283 "System.c"
		}
#line 45 "../lib/Services/System.vala"
		_tmp30_ = granite_services_system_privacy_settings;
#line 45 "../lib/Services/System.vala"
		result = g_settings_get_boolean (_tmp30_, "remember-recent-files");
#line 45 "../lib/Services/System.vala"
		return result;
#line 291 "System.c"
	}
#line 48 "../lib/Services/System.vala"
	result = TRUE;
#line 48 "../lib/Services/System.vala"
	return result;
#line 297 "System.c"
}

GraniteServicesSystem*
granite_services_system_construct (GType object_type)
{
	GraniteServicesSystem * self = NULL;
#line 11 "../lib/Services/System.vala"
	self = (GraniteServicesSystem*) g_object_new (object_type, NULL);
#line 11 "../lib/Services/System.vala"
	return self;
#line 308 "System.c"
}

GraniteServicesSystem*
granite_services_system_new (void)
{
#line 11 "../lib/Services/System.vala"
	return granite_services_system_construct (GRANITE_SERVICES_TYPE_SYSTEM);
#line 316 "System.c"
}

static void
granite_services_system_class_init (GraniteServicesSystemClass * klass,
                                    gpointer klass_data)
{
#line 11 "../lib/Services/System.vala"
	granite_services_system_parent_class = g_type_class_peek_parent (klass);
#line 11 "../lib/Services/System.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_services_system_finalize;
#line 327 "System.c"
}

static void
granite_services_system_instance_init (GraniteServicesSystem * self,
                                       gpointer klass)
{
}

static void
granite_services_system_finalize (GObject * obj)
{
	GraniteServicesSystem * self;
#line 11 "../lib/Services/System.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_SERVICES_TYPE_SYSTEM, GraniteServicesSystem);
#line 11 "../lib/Services/System.vala"
	G_OBJECT_CLASS (granite_services_system_parent_class)->finalize (obj);
#line 344 "System.c"
}

/**
     * Utility class for frequently-used system-related functions, such as opening files, launching
     * applications, or executing terminal commands.
     */
static GType
granite_services_system_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteServicesSystemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_services_system_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteServicesSystem), 0, (GInstanceInitFunc) granite_services_system_instance_init, NULL };
	GType granite_services_system_type_id;
	granite_services_system_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteServicesSystem", &g_define_type_info, 0);
	return granite_services_system_type_id;
}

GType
granite_services_system_get_type (void)
{
	static volatile gsize granite_services_system_type_id__once = 0;
	if (g_once_init_enter (&granite_services_system_type_id__once)) {
		GType granite_services_system_type_id;
		granite_services_system_type_id = granite_services_system_get_type_once ();
		g_once_init_leave (&granite_services_system_type_id__once, granite_services_system_type_id);
	}
	return granite_services_system_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

